import { reactive as te, ref as N, computed as ve, toRefs as we, defineComponent as ge, onMounted as Fe, resolveComponent as m, openBlock as d, createBlock as v, withCtx as a, createElementVNode as Q, renderSlot as H, createVNode as c, unref as e, createElementBlock as x, Fragment as I, renderList as J, mergeProps as R, withModifiers as ye, createTextVNode as K, toDisplayString as ne, createCommentVNode as L, resolveDirective as Ve, withDirectives as ie, createSlots as He, resolveDynamicComponent as Ne, normalizeProps as ze, guardReactiveProps as Ie, withKeys as Ke, vShow as We, isRef as qe } from "vue";
import { ElMessage as Te, ElMessageBox as Ee, ElNotification as je, ElButton as oe, ElButtonGroup as Qe, ElDialog as Je } from "element-plus";
import { useRoute as Ge } from "vue-router";
const ke = {
  debug: !1,
  mainMaxHeight: 700,
  isAfterMountQuery: !1,
  isOpenSearchForm: !1,
  Form_LabelWidth: 120,
  Dialog_Width: 800,
  Dialog_isFullscreen: !1,
  Dialog_isCloseOnPressEscape: !0,
  Dialog_isCloseOnClickModal: !1,
  Dialog_isFooterButton: !0,
  Table_isOpenIndex: !0,
  Table_isOpenMultipleSelection: !1,
  Table_isOpenExpand: !0,
  Table_ExpandColumn: 4,
  Table_IsShowMenu: !0,
  Table_MenuWidth: 200,
  Table_MenuAlign: "left",
  Page_PageSizes: [10, 20, 50, 100],
  Page_PageParams: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  Page_Layout: "->,total, sizes, prev, pager, next, jumper",
  Page_isHideOnSinglePage: !1,
  ApiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
}, Oe = {
  CompRef: {},
  Mode: "add",
  DialogVisible: !1,
  tableLoading: !1,
  submitLoading: !1,
  DialogVisibleFooterButton: !0,
  ElementArrs: { filter: {}, editor: {}, column: {}, columns: {} },
  tableColumn: [],
  originalData: [],
  tableData: [],
  multipleSelection: [],
  uploadFiles: [],
  initSearchModel: {},
  initEditModel: {},
  searchFormValue: {},
  searchModel: {},
  editFormValue: {},
  editModel: {}
}, Xe = {
  url: "",
  source: {}
};
function X(i) {
  let u;
  try {
    u = Array.isArray(i) ? [] : {}, i === null && (u = null);
  } catch {
    u = {};
  }
  for (const _ in i)
    typeof i[_] == "object" ? u[_] = X(i[_]) : u[_] = i[_];
  return u;
}
function Pe(...i) {
  function u(o) {
    return typeof o == "object" && Object.prototype.toString.call(o) === "[object Object]";
  }
  let _ = arguments.length, h = arguments[0];
  u(h) || (h = {});
  for (let o = 1; o < _; o++) {
    let y = arguments[o];
    if (u(y))
      for (let D in y)
        D === "__proto__" || h === y[D] || h.hasOwnProperty(D) && (u(y[D]) ? h[D] = Pe(h[D], y[D]) : h[D] = y[D]);
  }
  return h;
}
function Ye(i, u) {
  let _ = {}, h = Object.getOwnPropertyNames(i), o = Object.getOwnPropertyNames(u);
  return h.length === o.length && h.forEach((y) => {
    i[y] !== u[y] && (_[y] = u[y]);
  }), _;
}
const ae = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeBatchDeteleHandler: "beforeBatchDeteleHandler",
  afterBatchDeteleHandler: "afterBatchDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function Ze(i = { debug: !1 }) {
  const u = te({
    hooks: {}
  });
  return Object.keys(i).forEach((h) => {
    h !== "debug" && (u.hooks[h] = i[h]);
  }), {
    hookHandler: (h, o) => {
      let y = !1;
      try {
        i.debug && (console.group("DeBug\uFF1A", h), console.table(o.Data), console.groupEnd()), y = u.hooks[h](o);
      } catch {
        y = !0;
      }
      return y;
    }
  };
}
let B;
const de = N(), U = N({ ...ke }), s = N({ ...Oe }), O = N({ ...Xe }), el = (i) => {
  de.value = i.CrudRequest, U.value = Pe(ke, i), B = { ...U.value };
}, ll = (i) => {
  O.value = { ...i }, s.value = X(Oe), al(O.value.source), U.value = Pe(U.value, i);
};
function he() {
  return { ...we(U.value) };
}
function M() {
  return { ...we(s.value) };
}
function xe() {
  return { ...we(O.value) };
}
const Be = () => {
  const i = (t) => {
    let n = {};
    return O.value.rowKey && (n[O.value.rowKey] = t[O.value.rowKey]), O.value.rowKeys && O.value.rowKeys.forEach((F) => {
      n[F] = t[F];
    }), n;
  }, { hookHandler: u } = Ze(O.value.hooks);
  function _() {
    s.value.tableLoading = !0;
    const t = te({ ...s.value.initSearchModel, ...s.value.searchModel });
    for (const n in t)
      typeof t[n] == "string" && (t[n] = t[n].trim(), t[n] === "" && (t[n] = void 0)), t[n] === null && (t[n] = void 0);
    !u(ae.beforeQueryHandler, { CrudState: s, Data: t }) || de.value({
      url: O.value.url,
      name: U.value.ApiName.query,
      data: {
        pagenum: U.value.Page_PageParams.current,
        pagesize: U.value.Page_PageParams.pageSize,
        ...t
      }
    }).then((n) => {
      const { data: F, page: C } = n;
      setTimeout(() => {
        h(F, t), U.value.Page_PageParams.total = C.total, s.value.tableLoading = !1;
      }, 50);
    }).catch(() => {
      s.value.tableLoading = !1;
    });
  }
  const h = (t, n) => {
    Object.keys(n).filter((C) => n[C] != null).length == 0 && (s.value.originalData = t), s.value.originalData = X(t), u(ae.afterQueryHandler, { CrudState: s, Data: t }) && (s.value.tableData = X(t));
  };
  function o() {
    s.value.editModel = X(s.value.initEditModel);
    const t = te({ ...s.value.editModel });
    !u(ae.beforeAddHandler, { CrudState: s, Data: t }) || (s.value.Mode = "add", s.value.DialogVisible = !0);
  }
  const y = (t) => {
    const n = te({
      ...t
    });
    if (!u(ae.beforeEditHandler, { CrudState: s, Data: n }))
      return;
    const F = X(n);
    Object.keys(F).forEach((C) => {
      s.value.editModel[C] = F[C], s.value.editFormValue[C] = F[C];
    }), s.value.Mode = "edit", s.value.DialogVisible = !0;
  }, D = async (t) => {
    !t || await t.validate((n) => {
      if (n) {
        const F = te({
          ...s.value.editModel
        });
        if (!u(ae.beforeSubmitHandler, { CrudState: s, Data: F }))
          return;
        s.value.Mode === "add" ? E(F) : V(F);
      }
    });
  }, E = (t) => {
    s.value.submitLoading = !0;
    let n = t;
    t.FormData instanceof FormData && (n = t.FormData), de.value({ url: O.value.url, name: U.value.ApiName.add, data: n }).then(() => {
      s.value.DialogVisible = !1, be("\u65B0\u589E\u6210\u529F"), _(), s.value.submitLoading = !1;
    }).catch(() => {
      s.value.submitLoading = !1;
    });
  }, V = (t) => {
    s.value.submitLoading = !1;
    let n = t;
    if (t.FormData instanceof FormData)
      n = t.FormData;
    else {
      const F = Ye(s.value.editFormValue, n);
      if (JSON.stringify(F) === "{}")
        return s.value.submitLoading = !1, Te({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
      n = {
        ...i(t),
        ...F
      };
    }
    de.value({ url: O.value.url, name: U.value.ApiName.edit, data: n }).then(() => {
      s.value.DialogVisible = !1, be("\u7F16\u8F91\u6210\u529F"), _(), s.value.submitLoading = !1;
    }).catch(() => {
      s.value.submitLoading = !1;
    });
  };
  return {
    queryRecord: _,
    addRecord: o,
    editRecord: y,
    handleSubmit: D,
    delFlag: (t) => {
      Ee.confirm(`\u786E\u5B9A\u8981 \u201C${t.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = te({
          ...i(t),
          deleteFlag: t.deleteFlag == 0 ? 1 : 0
        });
        !u(ae.beforedisabledHandler, { CrudState: s, Data: n }) || de.value({
          url: O.value.url,
          name: U.value.ApiName.deleteFlag,
          data: n
        }).then(() => {
          be(`\u6570\u636E${t.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), _();
        });
      }).catch(() => {
      });
    },
    deleteRecord: (t) => {
      Ee.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = te({
          ...i(t)
        });
        !u(ae.beforeDeteleHandler, { CrudState: s, Data: n }) || de.value({
          url: O.value.url,
          name: U.value.ApiName.delete,
          data: n
        }).then(() => {
          be("\u5220\u9664\u6210\u529F"), _();
        });
      }).catch(() => {
      });
    },
    deleteMulRecord: () => {
      const t = s.value.multipleSelection.map((n) => n[O.value.rowKey]);
      Ee.confirm(`\u786E\u5B9A\u8981\u5220\u9664\u8FD9 ${t.length} \u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = te({
          [O.value.rowKey]: t,
          selection: s.value.multipleSelection
        });
        !u(ae.beforeBatchDeteleHandler, { CrudState: s, Data: n }) || de.value({
          url: O.value.url,
          name: U.value.ApiName.remove,
          data: n
        }).then(() => {
          be("\u6279\u91CF\u5220\u9664\u6210\u529F"), s.value.multipleSelection = [], s.value.CompRef.TableRef.clearSelection(), _();
        });
      }).catch(() => {
      });
    }
  };
};
function ol(...i) {
  U.value.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...i);
}
const al = (i) => {
  const { filter: u, editor: _, column: h, columns: o } = i;
  s.value.ElementArrs = { filter: {}, editor: {}, column: {}, columns: {} };
  let y = {};
  u.forEach((E) => {
    try {
      y[E] = o[E].searchDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", E);
    }
    s.value.ElementArrs.filter[E] = o[E];
  }), s.value.initSearchModel = X(y), s.value.searchModel = X(s.value.initSearchModel);
  let D = {};
  _.forEach((E) => {
    try {
      D[E] = o[E].addDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", E);
    }
    s.value.ElementArrs.editor[E] = o[E];
  }), s.value.initEditModel = X(D), h.forEach((E) => {
    s.value.ElementArrs.column[E] = o[E];
  }), s.value.ElementArrs.columns = o;
};
ve(() => {
  let i = [];
  for (const u in s.value.ElementArrs.editor)
    Object.prototype.hasOwnProperty.call(s.value.ElementArrs.editor, u) && s.value.ElementArrs.editor[u].type === "el-upload" && i.push(u);
  return i;
});
const be = (i, u = "success") => {
  je({
    title: i,
    type: u,
    offset: 70,
    duration: 2500
  });
}, tl = /* @__PURE__ */ ge({
  __name: "crud_SearchForm",
  setup(i) {
    const u = N(), { Form_LabelWidth: _ } = he(), {
      CompRef: h,
      searchModel: o,
      ElementArrs: {
        value: { filter: y }
      }
    } = M();
    Fe(() => {
      h.value.SearchFormRef = u.value;
    });
    const D = (V) => {
      var A, w;
      return V.range ? (A = V.formProps) != null && A.type ? V.formProps.type + "range" : "daterange" : (w = V.formProps) != null && w.type ? V.formProps.type : "date";
    }, E = (V, A, w) => {
      o.value[A] === w ? o.value[A] = void 0 : o.value[A] = V.formProps.options[w].value;
    };
    return (V, A) => {
      const w = m("el-input"), k = m("el-form-item"), t = m("el-col"), n = m("el-input-number"), F = m("el-option"), C = m("el-select"), S = m("el-date-picker"), $ = m("el-time-picker"), re = m("el-radio"), Y = m("el-radio-button"), Z = m("el-radio-group"), ue = m("el-row"), q = m("el-form"), ee = m("el-collapse-transition");
      return d(), v(ee, null, {
        default: a(() => [
          Q("div", null, [
            H(V.$slots, "search-form", {}, void 0, !0),
            c(q, {
              ref_key: "SearchFormRef",
              ref: u,
              model: e(o),
              "label-width": e(_)
            }, {
              default: a(() => [
                c(ue, null, {
                  default: a(() => [
                    H(V.$slots, "search-form-top", {}, void 0, !0),
                    (d(!0), x(I, null, J(e(y), (r, P) => {
                      var z;
                      return d(), x(I, null, [
                        r.type === "el-input" ? (d(), v(t, {
                          key: 0,
                          span: r.span ? r.span : 6
                        }, {
                          default: a(() => [
                            c(k, {
                              label: r.label,
                              prop: P
                            }, {
                              default: a(() => [
                                c(w, R({
                                  modelValue: e(o)[P],
                                  "onUpdate:modelValue": (g) => e(o)[P] = g,
                                  clearable: "",
                                  placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                }, r.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : r.type === "el-input-number" ? (d(), v(t, {
                          key: 1,
                          span: r.span ? r.span : 6
                        }, {
                          default: a(() => [
                            c(k, {
                              label: r.label,
                              prop: P
                            }, {
                              default: a(() => [
                                c(n, R({
                                  modelValue: e(o)[P],
                                  "onUpdate:modelValue": (g) => e(o)[P] = g,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165"
                                }, r.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : r.type === "el-select" ? (d(), v(t, {
                          key: 2,
                          span: r.span ? r.span : 6
                        }, {
                          default: a(() => [
                            c(k, {
                              label: r.label,
                              prop: P
                            }, {
                              default: a(() => [
                                c(C, R({
                                  style: { width: "100%" },
                                  modelValue: e(o)[P],
                                  "onUpdate:modelValue": (g) => e(o)[P] = g,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9"
                                }, r.formProps), {
                                  default: a(() => [
                                    (d(!0), x(I, null, J(r.formProps.options, (g) => (d(), v(F, {
                                      key: g.value,
                                      label: g.label,
                                      value: g.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : r.type === "el-date-picker" && !D(r).includes("range") ? (d(), v(t, {
                          key: 3,
                          span: r.span ? r.span : 6
                        }, {
                          default: a(() => [
                            c(k, {
                              label: r.label,
                              prop: P
                            }, {
                              default: a(() => [
                                c(S, R({
                                  modelValue: e(o)[P],
                                  "onUpdate:modelValue": (g) => e(o)[P] = g,
                                  "range-separator": "\u81F3",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, r.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : r.type === "el-date-picker" ? (d(), v(t, {
                          key: 4,
                          span: r.span ? r.span : 12
                        }, {
                          default: a(() => [
                            c(k, {
                              label: r.label,
                              prop: P
                            }, {
                              default: a(() => [
                                c(S, R({
                                  modelValue: e(o)[P],
                                  "onUpdate:modelValue": (g) => e(o)[P] = g,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, r.formProps, {
                                  type: D(r)
                                }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : r.type === "el-time-picker" && !((z = r.formProps) != null && z.isRange) && !r.range ? (d(), v(t, {
                          key: 5,
                          span: r.span ? r.span : 6
                        }, {
                          default: a(() => [
                            c(k, {
                              label: r.label,
                              prop: P
                            }, {
                              default: a(() => [
                                c($, R({
                                  style: { width: "100%" },
                                  modelValue: e(o)[P],
                                  "onUpdate:modelValue": (g) => e(o)[P] = g,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, r.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : r.type === "el-time-picker" ? (d(), v(t, {
                          key: 6,
                          span: r.span ? r.span : 12
                        }, {
                          default: a(() => [
                            c(k, {
                              label: r.label,
                              prop: P
                            }, {
                              default: a(() => [
                                c($, R({
                                  style: { width: "100%" },
                                  modelValue: e(o)[P],
                                  "onUpdate:modelValue": (g) => e(o)[P] = g,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, r.formProps, { "is-range": "" }), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : r.type === "el-radio-group" ? (d(), v(t, {
                          key: 7,
                          span: r.span ? r.span : 6
                        }, {
                          default: a(() => [
                            c(k, {
                              label: r.label,
                              prop: P
                            }, {
                              default: a(() => [
                                c(Z, R({
                                  modelValue: e(o)[P],
                                  "onUpdate:modelValue": (g) => e(o)[P] = g
                                }, r.formProps), {
                                  default: a(() => [
                                    r.formProps.button ? L("", !0) : (d(!0), x(I, { key: 0 }, J(r.formProps.options, (g) => (d(), v(re, R({
                                      key: g.value,
                                      label: g.value,
                                      onClick: ye((j) => E(r, P, g.value), ["prevent"])
                                    }, r.formProps), {
                                      default: a(() => [
                                        K(ne(g.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    r.formProps.button ? (d(!0), x(I, { key: 1 }, J(r.formProps.options, (g) => (d(), v(Y, R({
                                      key: g.value,
                                      label: g.value,
                                      onClick: ye((j) => E(r, P, g.value), ["prevent"])
                                    }, r.formProps), {
                                      default: a(() => [
                                        K(ne(g.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : L("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : L("", !0)
                      ], 64);
                    }), 256)),
                    H(V.$slots, "search-form-bottom", {}, void 0, !0)
                  ]),
                  _: 3
                })
              ]),
              _: 3
            }, 8, ["model", "label-width"])
          ])
        ]),
        _: 3
      });
    };
  }
});
const Ae = (i, u) => {
  const _ = i.__vccOpts || i;
  for (const [h, o] of u)
    _[h] = o;
  return _;
}, nl = /* @__PURE__ */ Ae(tl, [["__scopeId", "data-v-394e11ba"]]), rl = { class: "edit" }, ul = { class: "edit_form" }, sl = /* @__PURE__ */ ge({
  __name: "crud_EditForm",
  props: {
    height: Number
  },
  setup(i) {
    const u = N(), { Form_LabelWidth: _ } = he(), { CompRef: h, editModel: o, Mode: y, ElementArrs: D, uploadFiles: E } = M();
    Fe(() => {
      h.value.EditFormRef = u.value;
    });
    const V = ve(() => {
      let n = {};
      const F = xe().source.value.editor, C = D.value.editor;
      return F.forEach((S) => {
        C[S].visible && typeof C[S].visible == "function" ? C[S].visible(M(), y.value) && (n[S] = C[S]) : n[S] = C[S];
      }), n;
    }), A = ({ showFileList: n }) => {
      if (n)
        return !1;
      if (E.value[0])
        return URL.createObjectURL(E.value[0]);
    }, w = (n) => typeof n.disabled == "function" ? n.disabled(M(), y.value) : !1, k = (n) => {
      let F = { ...n };
      return Object.keys(F).forEach((C) => {
        typeof F[C] == "function" && (F[C] = F[C].bind(this, M()));
      }), F;
    }, t = (n, F, C) => {
      o.value[F] === C ? o.value[F] = void 0 : o.value[F] = n.formProps.options[C].value;
    };
    return (n, F) => {
      const C = m("el-input"), S = m("el-form-item"), $ = m("el-col"), re = m("el-input-number"), Y = m("el-option"), Z = m("el-select"), ue = m("el-date-picker"), q = m("el-time-picker"), ee = m("el-cascader"), r = m("el-button"), P = m("el-image"), z = m("plus"), g = m("el-icon"), j = m("el-upload"), ce = m("el-radio"), pe = m("el-radio-button"), fe = m("el-radio-group"), _e = m("el-row"), me = m("el-form"), b = m("el-scrollbar");
      return d(), x("div", rl, [
        c(b, {
          height: i.height,
          "max-height": i.height
        }, {
          default: a(() => [
            Q("div", ul, [
              H(n.$slots, "edit-form", { editModel: e(o) }, void 0, !0),
              c(me, {
                ref_key: "EditFormRef",
                ref: u,
                model: e(o),
                "label-width": e(_)
              }, {
                default: a(() => [
                  c(_e, null, {
                    default: a(() => [
                      H(n.$slots, "edit-form-top", { editModel: e(o) }, void 0, !0),
                      (d(!0), x(I, null, J(e(V), (l, p) => (d(), x(I, { key: p }, [
                        l.type === "el-input" ? (d(), v($, {
                          key: 0,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            c(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                c(C, R({
                                  style: { width: "100%" },
                                  modelValue: e(o)[p],
                                  "onUpdate:modelValue": (f) => e(o)[p] = f,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: w(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-input-number" ? (d(), v($, {
                          key: 1,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            c(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                c(re, R({
                                  style: { width: "100%" },
                                  modelValue: e(o)[p],
                                  "onUpdate:modelValue": (f) => e(o)[p] = f,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: w(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-select" ? (d(), v($, {
                          key: 2,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            c(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                c(Z, R({
                                  style: { width: "100%" },
                                  modelValue: e(o)[p],
                                  "onUpdate:modelValue": (f) => e(o)[p] = f,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  disabled: w(l)
                                }, l.formProps), {
                                  default: a(() => [
                                    (d(!0), x(I, null, J(l.formProps.options, (f) => (d(), v(Y, {
                                      key: f.value,
                                      label: f.label,
                                      value: f.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-date-picker" ? (d(), v($, {
                          key: 3,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            c(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                c(ue, R({
                                  style: { width: "100%" },
                                  modelValue: e(o)[p],
                                  "onUpdate:modelValue": (f) => e(o)[p] = f,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: w(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-time-picker" ? (d(), v($, {
                          key: 4,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            c(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                c(q, R({
                                  style: { width: "100%" },
                                  modelValue: e(o)[p],
                                  "onUpdate:modelValue": (f) => e(o)[p] = f,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: w(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-cascader" ? (d(), v($, {
                          key: 5,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            c(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                c(ee, R({
                                  style: { width: "100%" },
                                  modelValue: e(o)[p],
                                  "onUpdate:modelValue": (f) => e(o)[p] = f,
                                  props: l.formProps.props,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  "show-all-levels": !1,
                                  disabled: w(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-upload" ? (d(), v($, {
                          key: 6,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            c(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                c(j, R({
                                  style: { width: "100%" },
                                  ref_for: !0,
                                  ref: p + "UploadRef",
                                  action: ""
                                }, k(l.formProps)), {
                                  default: a(() => {
                                    var f;
                                    return [
                                      ((f = l.formProps) == null ? void 0 : f.listType) !== "picture-card" ? (d(), v(r, {
                                        key: 0,
                                        type: "primary"
                                      }, {
                                        default: a(() => [
                                          K(ne(l.formProps.butName || "\u70B9\u51FB\u4E0A\u4F20\u6587\u4EF6"), 1)
                                        ]),
                                        _: 2
                                      }, 1024)) : L("", !0),
                                      l.formProps.listType === "picture-card" && A(l.formProps) ? (d(), v(P, {
                                        key: 1,
                                        style: { width: "146px", height: "146px", "border-radius": "5px" },
                                        fit: "contain",
                                        src: A(l.formProps)
                                      }, null, 8, ["src"])) : L("", !0),
                                      l.formProps.listType == "picture-card" && !A(l.formProps) ? (d(), v(g, { key: 2 }, {
                                        default: a(() => [
                                          c(z)
                                        ]),
                                        _: 1
                                      })) : L("", !0)
                                    ];
                                  }),
                                  _: 2
                                }, 1040)
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-radio-group" ? (d(), v($, {
                          key: 7,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            c(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                c(fe, R({
                                  modelValue: e(o)[p],
                                  "onUpdate:modelValue": (f) => e(o)[p] = f,
                                  disabled: w(l)
                                }, l.formProps), {
                                  default: a(() => [
                                    l.formProps.button ? L("", !0) : (d(!0), x(I, { key: 0 }, J(l.formProps.options, (f) => (d(), v(ce, R({
                                      key: f.value,
                                      label: f.value,
                                      onClick: ye((le) => t(l, p, f.value), ["prevent"])
                                    }, l.formProps), {
                                      default: a(() => [
                                        K(ne(f.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    l.formProps.button ? (d(!0), x(I, { key: 1 }, J(l.formProps.options, (f) => (d(), v(pe, R({
                                      key: f.value,
                                      label: f.value,
                                      onClick: ye((le) => t(l, p, f.value), ["prevent"])
                                    }, l.formProps), {
                                      default: a(() => [
                                        K(ne(f.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : L("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : L("", !0)
                      ], 64))), 128)),
                      H(n.$slots, "edit-form-bottom", { editModel: e(o) }, void 0, !0)
                    ]),
                    _: 3
                  })
                ]),
                _: 3
              }, 8, ["model", "label-width"])
            ])
          ]),
          _: 3
        }, 8, ["height", "max-height"])
      ]);
    };
  }
});
const dl = /* @__PURE__ */ Ae(sl, [["__scopeId", "data-v-ef911526"]]), il = { key: 1 }, cl = /* @__PURE__ */ ge({
  __name: "crud_Table",
  props: { height: Number },
  emits: ["row-contextmenu"],
  setup(i, { emit: u }) {
    const _ = N(), { Table_isOpenMultipleSelection: h, Table_isOpenIndex: o, Table_isOpenExpand: y, Table_ExpandColumn: D, Table_MenuAlign: E, Table_IsShowMenu: V, Table_MenuWidth: A, Page_PageParams: w, Permission: k, Permissions: t } = he(), {
      CompRef: n,
      tableData: F,
      tableLoading: C,
      ElementArrs: {
        value: { filter: S, column: $, columns: re }
      },
      searchModel: Y,
      multipleSelection: Z
    } = M(), { rowKey: ue, keyName: q, Table_Attributes: ee } = xe(), { queryRecord: r, editRecord: P, delFlag: z, deleteRecord: g } = Be();
    Fe(() => {
      n.value.TableRef = _.value;
    });
    const j = ve(() => (w.value.current - 1) * w.value.pageSize + 1), ce = (b) => {
      Z.value = b;
    }, pe = (b, l, p, f) => {
      l.label && navigator.clipboard.writeText(p.innerText).then(() => {
        Te.success("\u590D\u5236\u6210\u529F\uFF01");
      });
    }, fe = (b, l, p) => {
      p.preventDefault(), u("row-contextmenu", { row: b, column: l, event: p }, M());
    }, _e = (b, l, p) => {
      if (l.formProps && l.formProps.options) {
        const f = l.formProps.options.findIndex((le) => le.value == b[p]);
        return f === -1 ? b[p] : l.formProps.options[f].label;
      } else
        return b[p];
    }, me = (b, l) => {
      let p = { ...b };
      return Object.keys(p).forEach((f) => {
        typeof p[f] == "function" && (p[f] = p[f].call(this, M(), l));
      }), p;
    };
    return (b, l) => {
      const p = m("el-empty"), f = m("el-table-column"), le = m("el-descriptions-item"), W = m("el-descriptions"), $e = m("el-input"), De = m("el-button"), Ue = m("el-table"), Ce = Ve("Auth"), Le = Ve("loading");
      return ie((d(), v(Ue, R({
        ref_key: "TableRef",
        ref: _,
        data: e(F),
        "row-key": e(ue),
        height: i.height,
        onCellDblclick: pe,
        onSelectionChange: ce,
        onRowContextmenu: fe
      }, e(ee)), {
        empty: a(() => [
          c(p, {
            "image-size": 80,
            description: "\u6682\u65E0\u6570\u636E"
          })
        ]),
        default: a(() => [
          e(h) ? (d(), v(f, {
            key: 0,
            type: "selection",
            "reserve-selection": "",
            width: 44
          })) : L("", !0),
          e(y) ? (d(), v(f, {
            key: 1,
            type: "expand",
            width: 35
          }, {
            default: a(({ row: T }) => [
              c(W, {
                column: e(D),
                border: ""
              }, {
                default: a(() => [
                  (d(!0), x(I, null, J(e(re), (G, se) => (d(), x(I, { key: se }, [
                    G.hidden ? L("", !0) : (d(), v(le, {
                      key: 0,
                      label: G.label
                    }, {
                      default: a(() => [
                        K(ne(_e(T, G, se)), 1)
                      ]),
                      _: 2
                    }, 1032, ["label"]))
                  ], 64))), 128))
                ]),
                _: 2
              }, 1032, ["column"])
            ]),
            _: 1
          })) : L("", !0),
          e(o) ? (d(), v(f, {
            key: 2,
            label: "###",
            width: 55,
            align: "right",
            "show-overflow-tooltip": ""
          }, {
            default: a(({ $index: T }) => [
              K(ne(e(j) + T), 1)
            ]),
            _: 1
          })) : L("", !0),
          (d(!0), x(I, null, J(e($), (T, G) => (d(), v(f, R({
            key: G,
            align: T.align || "left",
            label: T.label,
            prop: G
          }, T.tableProps, { "show-overflow-tooltip": "" }), He({ _: 2 }, [
            T.columnSlot ? {
              name: "default",
              fn: a((se) => [
                (d(), v(Ne(T.columnSlot.is), ze(Ie(me(T.columnSlot, se))), null, 16))
              ])
            } : void 0
          ]), 1040, ["align", "label", "prop"]))), 128)),
          H(b.$slots, "table-column"),
          e(V) ? (d(), v(f, {
            key: 3,
            align: e(E) || "left",
            width: e(A)
          }, {
            header: a(() => [
              e(q) ? (d(), v($e, {
                key: 0,
                modelValue: e(Y)[e(q)],
                "onUpdate:modelValue": l[0] || (l[0] = (T) => e(Y)[e(q)] = T),
                placeholder: e(S)[e(q)].label + "\u6A21\u7CCA\u67E5\u627E",
                clearable: "",
                onKeyup: Ke(e(r), ["enter", "native"])
              }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : (d(), x("span", il, "\u64CD\u4F5C"))
            ]),
            default: a((T) => {
              var G, se, Me;
              return [
                H(b.$slots, "menu-top", { scope: T }),
                ie((d(), v(De, {
                  plain: "",
                  type: T.row[e(k).deleteFlag] ? "danger" : "success",
                  onClick: (Re) => e(z)(T.row)
                }, {
                  default: a(() => [
                    K(ne(T.row[e(k).deleteFlag] ? "\u7981\u7528" : "\u542F\u7528"), 1)
                  ]),
                  _: 2
                }, 1032, ["type", "onClick"])), [
                  [Ce, { Permissions: e(t), access: [(G = e(k)) == null ? void 0 : G.deleteFlag] }]
                ]),
                ie(c(De, {
                  plain: "",
                  type: "primary",
                  icon: "edit",
                  onClick: (Re) => e(P)(T.row)
                }, null, 8, ["onClick"]), [
                  [Ce, { Permissions: e(t), access: [(se = e(k)) == null ? void 0 : se.edit] }]
                ]),
                ie(c(De, {
                  plain: "",
                  type: "danger",
                  icon: "delete",
                  onClick: (Re) => e(g)(T.row)
                }, null, 8, ["onClick"]), [
                  [Ce, { Permissions: e(t), access: [(Me = e(k)) == null ? void 0 : Me.delete] }]
                ]),
                H(b.$slots, "menu-bottom", { scope: T })
              ];
            }),
            _: 3
          }, 8, ["align", "width"])) : L("", !0)
        ]),
        _: 3
      }, 16, ["data", "row-key", "height"])), [
        [Le, e(C)]
      ]);
    };
  }
}), pl = /* @__PURE__ */ ge({
  __name: "crud_Pagination",
  setup(i) {
    const { Page_PageSizes: u, Page_PageParams: _, Page_Layout: h, Page_isHideOnSinglePage: o } = he(), { queryRecord: y } = Be(), D = (V) => {
      _.value.pageSize = V, y();
    }, E = (V) => {
      _.value.current = V, _.value.current != null && y();
    };
    return (V, A) => {
      const w = m("el-pagination");
      return d(), v(w, {
        "hide-on-single-page": e(o),
        "current-page": e(_).current,
        "page-size": e(_).pageSize,
        "page-sizes": e(u),
        background: "",
        layout: e(h),
        total: e(_).total,
        onSizeChange: D,
        onCurrentChange: E
      }, null, 8, ["hide-on-single-page", "current-page", "page-size", "page-sizes", "layout", "total"]);
    };
  }
}), fl = { style: { padding: "20px", "background-color": "#fff", "border-radius": "20px" } }, _l = { class: "butSlotDiv" }, ml = { class: "button_left" }, bl = /* @__PURE__ */ K(" \u65B0\u589E "), vl = /* @__PURE__ */ K(" \u6279\u91CF\u5220\u9664 "), gl = { class: "button_right" }, hl = { style: { display: "flex", "justify-content": "flex-end" } }, yl = /* @__PURE__ */ K("\u53D6\u6D88"), Fl = /* @__PURE__ */ K("\u91CD\u7F6E"), Pl = /* @__PURE__ */ K("\u63D0\u4EA4"), Dl = /* @__PURE__ */ ge({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    debug: { type: Boolean, default: () => B.debug },
    mainMaxHeight: { default: () => B.mainMaxHeight },
    isAfterMountQuery: { type: Boolean, default: () => B.isAfterMountQuery },
    isOpenSearchForm: { type: Boolean, default: () => B.isOpenSearchForm },
    Form_LabelWidth: { default: () => B.Form_LabelWidth },
    Dialog_Width: { default: () => B.Dialog_Width },
    Dialog_isFullscreen: { type: Boolean, default: () => B.Dialog_isFullscreen },
    Dialog_isCloseOnPressEscape: { type: Boolean, default: () => B.Dialog_isCloseOnPressEscape },
    Dialog_isCloseOnClickModal: { type: Boolean, default: () => B.Dialog_isCloseOnClickModal },
    Dialog_isFooterButton: { type: Boolean, default: () => B.Dialog_isFooterButton },
    Table_Attributes: null,
    Table_isOpenIndex: { type: Boolean, default: () => B.Table_isOpenIndex },
    Table_isOpenMultipleSelection: { type: Boolean, default: () => B.Table_isOpenMultipleSelection },
    Table_isOpenExpand: { type: Boolean, default: () => B.Table_isOpenExpand },
    Table_ExpandColumn: { default: () => B.Table_ExpandColumn },
    Table_IsShowMenu: { type: Boolean, default: () => B.Table_IsShowMenu },
    Table_MenuWidth: { default: () => B.Table_MenuWidth },
    Page_PageSizes: { default: () => B.Page_PageSizes },
    Page_PageParams: { default: () => B.Page_PageParams },
    Page_Layout: { default: () => B.Page_Layout },
    Page_isHideOnSinglePage: { type: Boolean, default: () => B.Page_isHideOnSinglePage },
    ApiName: { default: () => B.ApiName },
    Permission: { default: () => B.Permission },
    Permissions: { default: () => B.Permissions }
  },
  emits: ["row-contextmenu"],
  setup(i, { expose: u, emit: _ }) {
    const h = i, o = Ge();
    ll(h);
    const { queryRecord: y, addRecord: D, handleSubmit: E, deleteMulRecord: V } = Be(), { CompRef: A, initSearchModel: w, Mode: k, DialogVisible: t, multipleSelection: n, submitLoading: F, DialogVisibleFooterButton: C } = M(), { isOpenSearchForm: S, isAfterMountQuery: $, Table_isOpenMultipleSelection: re, Dialog_Width: Y, Dialog_isFullscreen: Z, Dialog_isCloseOnPressEscape: ue, Dialog_isCloseOnClickModal: q, Permission: ee, Permissions: r } = he();
    if (o.params.data) {
      ol("\u8DEF\u7531\u4F20\u53C2\uFF1A", o.params.data);
      let b = o.params.data, l = JSON.parse(b);
      w.value = Pe(w.value, l);
    }
    const P = N(), z = N(), g = N(), j = N(), ce = N(0), pe = N(0);
    Fe(() => {
      const b = z.value.children[0].style.display;
      z.value.children[0].style.display = "block", ce.value = P.value.offsetHeight - 40 - z.value.offsetHeight - g.value.offsetHeight - j.value.offsetHeight, pe.value = P.value.offsetHeight - 40 - g.value.offsetHeight - j.value.offsetHeight, z.value.children[0].style.display = b, A.value.containerDivRef = P.value, A.value.searchDivRef = z.value, A.value.buttonDivRef = g.value, A.value.paginationDivRef = j.value, $.value && y();
    });
    const fe = ve(() => S.value ? ce.value : pe.value), _e = ve(() => {
      const b = N(document.documentElement.clientHeight);
      return Z.value ? b.value - 54 - 62 - 2 : b.value - 54 - 62 - 2 - b.value * 0.15 - 50;
    }), me = ({ row: b, event: l }, p) => {
      _("row-contextmenu", { row: b, event: l }, p);
    };
    return u({
      ...M()
    }), (b, l) => {
      var f, le;
      const p = Ve("Auth");
      return d(), x("div", {
        ref_key: "containerDivRef",
        ref: P,
        style: { height: "100%" }
      }, [
        Q("div", fl, [
          Q("div", {
            ref_key: "searchDivRef",
            ref: z
          }, [
            ie(c(nl, null, {
              "search-form": a(() => [
                H(b.$slots, "search-form", {
                  CrudState: e(M)()
                }, void 0, !0)
              ]),
              "search-form-top": a(() => [
                H(b.$slots, "search-form-top", {
                  CrudState: e(M)()
                }, void 0, !0)
              ]),
              "search-form-bottom": a(() => [
                H(b.$slots, "search-form-bottom", {
                  CrudState: e(M)()
                }, void 0, !0)
              ]),
              _: 3
            }, 512), [
              [We, e(S)]
            ])
          ], 512),
          Q("div", {
            ref_key: "buttonDivRef",
            ref: g,
            class: "buttonDiv"
          }, [
            Q("div", _l, [
              Q("div", ml, [
                ie((d(), v(e(oe), {
                  type: "primary",
                  icon: "plus",
                  onClick: e(D)
                }, {
                  default: a(() => [
                    bl
                  ]),
                  _: 1
                }, 8, ["onClick"])), [
                  [p, { Permissions: e(r), access: [(f = e(ee)) == null ? void 0 : f.add] }]
                ]),
                e(re) ? ie((d(), v(e(oe), {
                  key: 0,
                  disabled: e(n).length <= 0,
                  type: "danger",
                  icon: "delete",
                  onClick: e(V)
                }, {
                  default: a(() => [
                    vl
                  ]),
                  _: 1
                }, 8, ["disabled", "onClick"])), [
                  [p, { Permissions: e(r), access: [(le = e(ee)) == null ? void 0 : le.remove] }]
                ]) : L("", !0),
                H(b.$slots, "button-left", {
                  CrudState: e(M)()
                }, void 0, !0)
              ]),
              Q("div", gl, [
                H(b.$slots, "button-right", {
                  CrudState: e(M)()
                }, void 0, !0)
              ])
            ]),
            c(e(Qe), { style: { "flex-shrink": "0", width: "150px" } }, {
              default: a(() => [
                c(e(oe), {
                  color: "#67c23a",
                  icon: "search",
                  onClick: e(y)
                }, null, 8, ["onClick"]),
                c(e(oe), {
                  color: "#e6a23c",
                  icon: "refresh",
                  onClick: l[0] || (l[0] = (W) => e(A).SearchFormRef.resetFields())
                }),
                c(e(oe), {
                  color: "#409eff",
                  icon: "expand",
                  onClick: l[1] || (l[1] = (W) => S.value = !e(S))
                })
              ]),
              _: 1
            })
          ], 512),
          c(cl, {
            height: e(fe),
            onRowContextmenu: me
          }, {
            "table-column": a(() => [
              H(b.$slots, "table-column", {
                CrudState: e(M)()
              }, void 0, !0)
            ]),
            "menu-top": a(({ scope: W }) => [
              H(b.$slots, "menu-top", {
                scope: W,
                CrudState: e(M)()
              }, void 0, !0)
            ]),
            "menu-bottom": a(({ scope: W }) => [
              H(b.$slots, "menu-bottom", {
                scope: W,
                CrudState: e(M)()
              }, void 0, !0)
            ]),
            _: 3
          }, 8, ["height"]),
          Q("div", {
            ref_key: "paginationDivRef",
            ref: j,
            style: { "padding-top": "20px" }
          }, [
            c(pl)
          ], 512),
          c(e(Je), {
            class: "DialogVisible",
            modelValue: e(t),
            "onUpdate:modelValue": l[5] || (l[5] = (W) => qe(t) ? t.value = W : null),
            title: e(k) === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: e(Y),
            "destroy-on-close": "",
            "close-on-press-escape": e(ue),
            fullscreen: e(Z),
            "close-on-click-modal": e(q)
          }, He({
            default: a(() => [
              c(dl, { height: e(_e) }, {
                "edit-form": a(() => [
                  H(b.$slots, "edit-form", {
                    CrudState: e(M)()
                  }, void 0, !0)
                ]),
                "edit-form-top": a(() => [
                  H(b.$slots, "edit-form-top", {
                    CrudState: e(M)()
                  }, void 0, !0)
                ]),
                "edit-form-bottom": a(() => [
                  H(b.$slots, "edit-form-bottom", {
                    CrudState: e(M)()
                  }, void 0, !0)
                ]),
                _: 3
              }, 8, ["height"])
            ]),
            _: 2
          }, [
            e(C) ? {
              name: "footer",
              fn: a(() => [
                Q("div", hl, [
                  H(b.$slots, "edit-form-footer", {
                    CrudState: e(M)()
                  }, void 0, !0),
                  c(e(oe), {
                    onClick: l[2] || (l[2] = (W) => t.value = !1)
                  }, {
                    default: a(() => [
                      yl
                    ]),
                    _: 1
                  }),
                  c(e(oe), {
                    type: "warning",
                    plain: "",
                    onClick: l[3] || (l[3] = (W) => e(A).EditFormRef.resetFields())
                  }, {
                    default: a(() => [
                      Fl
                    ]),
                    _: 1
                  }),
                  c(e(oe), {
                    type: "primary",
                    loading: e(F),
                    onClick: l[4] || (l[4] = (W) => e(E)(e(A).EditFormRef))
                  }, {
                    default: a(() => [
                      Pl
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "close-on-press-escape", "fullscreen", "close-on-click-modal"])
        ])
      ], 512);
    };
  }
});
const Se = /* @__PURE__ */ Ae(Dl, [["__scopeId", "data-v-ddf03803"]]), Cl = {
  mounted(i, u, _) {
    const h = u.value.Permissions, o = u.value.access;
    let y = !1;
    for (let D = 0; D < o.length; D++)
      h.includes(o[D]) && (y = !0);
    y || i.parentNode && i.parentNode.removeChild(i);
  }
};
Se.install = (i) => {
  i.component("CrudEl", Se), i.directive("Auth", Cl);
};
const wl = (i, u) => {
  u ? (u.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), el(u), i.use(Se)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  Pe as DataMerger,
  X as DeepClone,
  el as InitSys,
  wl as createCrudEl,
  ae as hooksName,
  Ye as isObjEqual,
  Ze as useHooks
};
